VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{1310A530-4250-4C09-BCFE-A8C413E972AD}#60.2#0"; "BESchedule.ocx"
Begin VB.Form frmMain 
   Caption         =   "BESchedule Sample Application"
   ClientHeight    =   5460
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8910
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   5460
   ScaleWidth      =   8910
   StartUpPosition =   2  'CenterScreen
   Begin BESchedule.Schedule Schedule1 
      Height          =   4995
      Left            =   60
      TabIndex        =   1
      Top             =   60
      Width           =   8745
      _ExtentX        =   15425
      _ExtentY        =   8811
   End
   Begin VB.Timer ClockTimer 
      Interval        =   500
      Left            =   108
      Top             =   5112
   End
   Begin MSComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   348
      Left            =   0
      TabIndex        =   0
      Top             =   5112
      Width           =   8904
      _ExtentX        =   15716
      _ExtentY        =   609
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   2
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   1
            Object.Width           =   12621
            Text            =   "Active/Not Active"
            TextSave        =   "Active/Not Active"
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   2
            Text            =   "Date/Time"
            TextSave        =   "Date/Time"
         EndProperty
      EndProperty
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Enum DayOfWeek
    DAY_MONDAY = 0
    DAY_TUESDAY = 1
    DAY_WEDNESDAY = 2
    DAY_THURSDAY = 3
    DAY_FRIDAY = 4
    DAY_SATURDAY = 5
    DAY_SUNDAY = 6
    DAY_SPECIAL = 8
End Enum

Private Enum TimeEvents
    SCHEDULE_START = 0
    SCHEDULE_STOP = 1
End Enum

Private Enum TimePeriod
    PERIOD_1 = 0
    PERIOD_2 = 1
    PERIOD_3 = 2
    PERIOD_4 = 3
End Enum

Private m_iTimeValue(8, 4, 2) As Integer
Const INI_FILE_NAME = "sample.ini"

Private Sub ClockTimer_Timer()
Dim n_strTimeString As String, n_strDateString As String, n_strTimeStamp As String

n_strDateString = Format(Date$, "mmm dd, yyyy")
n_strTimeString = Format(Time$, "hh:mm:ss AMPM")
n_strTimeStamp = n_strDateString & Space(5) & n_strTimeString & Space(5)
StatusBar1.Panels(2).Text = n_strTimeStamp

If IsDateTimeActive(Now()) Then
    StatusBar1.Panels(1).Text = "Current time in schedule"
Else
    StatusBar1.Panels(1).Text = "Current time not in schedule"
End If

End Sub

Private Sub Form_Load()
If ReadValuesFromINIFile Then Call LoadTimeValueArray
End Sub

Private Sub Form_Unload(Cancel As Integer)
Call WriteValuesToINIFile
End Sub

Private Sub Schedule1_ScheduleUpdated()
Call LoadTimeValueArray
End Sub
'******************************************
'* This function checks to see if a date/time value passed in is currently "active" (in a scheule period)
'* Input:      A date/time string (typically, Now(), but could be any valid date/time stamp)
'* Output:     true if the date/time is active
'* Programmer: MBevan
'* Date:       23/Oct/2005
'******************************************
Public Function IsDateTimeActive(strDateTime As String) As Boolean
Dim n_bReturnValue As Boolean
Dim i As Integer, n_iWeekdayValue As Integer
Dim n_iHour As Integer, n_iMinuteValue As Integer, n_iCurrentTimeValue As Integer
Dim n_strMessage As String

On Error GoTo EH_IsDateTimeActive
n_bReturnValue = False

'if it's not a valid date/time, don't bother
If Not IsDate(strDateTime) Then GoTo NormalExit_IsDateTimeActive

'get the weekday - monday is day #1 . Since it's one-based, subract 1
n_iWeekdayValue = Weekday(strDateTime, vbMonday) - 1
n_iHour = Hour(strDateTime) * 100
n_iMinuteValue = Minute(strDateTime)
n_iCurrentTimeValue = n_iHour + n_iMinuteValue

For i = PERIOD_1 To PERIOD_4
    If n_iCurrentTimeValue >= m_iTimeValue(n_iWeekdayValue, i, SCHEDULE_START) And _
        n_iCurrentTimeValue <= m_iTimeValue(n_iWeekdayValue, i, SCHEDULE_STOP) Then
        n_bReturnValue = True
        Exit For
    End If
Next i

NormalExit_IsDateTimeActive:
    On Error GoTo Resume_IsDateTimeActive
    'Clean up
    IsDateTimeActive = n_bReturnValue
    On Error GoTo 0
    Exit Function

EH_IsDateTimeActive:
    n_strMessage = "Failed to check date for active with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_IsDateTimeActive

Resume_IsDateTimeActive:
    Err.Clear
    Resume Next

End Function
'******************************************
'* This function simply loads the BESchedule properties into arrays
'* Input:      None
'* Output:     None
'* Programmer: MBevan
'* Date:       23/Oct/2005
'******************************************
Private Sub LoadTimeValueArray()
Dim n_strMessage As String

On Error GoTo EH_LoadTimeValueArray

m_iTimeValue(DAY_MONDAY, PERIOD_1, SCHEDULE_START) = Schedule1.Schedule_MondayStart1
m_iTimeValue(DAY_MONDAY, PERIOD_1, SCHEDULE_STOP) = Schedule1.Schedule_MondayStop1
m_iTimeValue(DAY_MONDAY, PERIOD_2, SCHEDULE_START) = Schedule1.Schedule_MondayStart2
m_iTimeValue(DAY_MONDAY, PERIOD_2, SCHEDULE_STOP) = Schedule1.Schedule_MondayStop2
m_iTimeValue(DAY_MONDAY, PERIOD_3, SCHEDULE_START) = Schedule1.Schedule_MondayStart3
m_iTimeValue(DAY_MONDAY, PERIOD_3, SCHEDULE_STOP) = Schedule1.Schedule_MondayStop3
m_iTimeValue(DAY_MONDAY, PERIOD_4, SCHEDULE_START) = Schedule1.Schedule_MondayStart4
m_iTimeValue(DAY_MONDAY, PERIOD_4, SCHEDULE_STOP) = Schedule1.Schedule_MondayStop4

m_iTimeValue(DAY_TUESDAY, PERIOD_1, SCHEDULE_START) = Schedule1.Schedule_TuesdayStart1
m_iTimeValue(DAY_TUESDAY, PERIOD_1, SCHEDULE_STOP) = Schedule1.Schedule_TuesdayStop1
m_iTimeValue(DAY_TUESDAY, PERIOD_2, SCHEDULE_START) = Schedule1.Schedule_TuesdayStart2
m_iTimeValue(DAY_TUESDAY, PERIOD_2, SCHEDULE_STOP) = Schedule1.Schedule_TuesdayStop2
m_iTimeValue(DAY_TUESDAY, PERIOD_3, SCHEDULE_START) = Schedule1.Schedule_TuesdayStart3
m_iTimeValue(DAY_TUESDAY, PERIOD_3, SCHEDULE_STOP) = Schedule1.Schedule_TuesdayStop3
m_iTimeValue(DAY_TUESDAY, PERIOD_4, SCHEDULE_START) = Schedule1.Schedule_TuesdayStart4
m_iTimeValue(DAY_TUESDAY, PERIOD_4, SCHEDULE_STOP) = Schedule1.Schedule_TuesdayStop4

m_iTimeValue(DAY_WEDNESDAY, PERIOD_1, SCHEDULE_START) = Schedule1.Schedule_WednesdayStart1
m_iTimeValue(DAY_WEDNESDAY, PERIOD_1, SCHEDULE_STOP) = Schedule1.Schedule_WednesdayStop1
m_iTimeValue(DAY_WEDNESDAY, PERIOD_2, SCHEDULE_START) = Schedule1.Schedule_WednesdayStart2
m_iTimeValue(DAY_WEDNESDAY, PERIOD_2, SCHEDULE_STOP) = Schedule1.Schedule_WednesdayStop2
m_iTimeValue(DAY_WEDNESDAY, PERIOD_3, SCHEDULE_START) = Schedule1.Schedule_WednesdayStart3
m_iTimeValue(DAY_WEDNESDAY, PERIOD_3, SCHEDULE_STOP) = Schedule1.Schedule_WednesdayStop3
m_iTimeValue(DAY_WEDNESDAY, PERIOD_4, SCHEDULE_START) = Schedule1.Schedule_WednesdayStart4
m_iTimeValue(DAY_WEDNESDAY, PERIOD_4, SCHEDULE_STOP) = Schedule1.Schedule_WednesdayStop4

m_iTimeValue(DAY_THURSDAY, PERIOD_1, SCHEDULE_START) = Schedule1.Schedule_ThursdayStart1
m_iTimeValue(DAY_THURSDAY, PERIOD_1, SCHEDULE_STOP) = Schedule1.Schedule_ThursdayStop1
m_iTimeValue(DAY_THURSDAY, PERIOD_2, SCHEDULE_START) = Schedule1.Schedule_ThursdayStart2
m_iTimeValue(DAY_THURSDAY, PERIOD_2, SCHEDULE_STOP) = Schedule1.Schedule_ThursdayStop2
m_iTimeValue(DAY_THURSDAY, PERIOD_3, SCHEDULE_START) = Schedule1.Schedule_ThursdayStart3
m_iTimeValue(DAY_THURSDAY, PERIOD_3, SCHEDULE_STOP) = Schedule1.Schedule_ThursdayStop3
m_iTimeValue(DAY_THURSDAY, PERIOD_4, SCHEDULE_START) = Schedule1.Schedule_ThursdayStart4
m_iTimeValue(DAY_THURSDAY, PERIOD_4, SCHEDULE_STOP) = Schedule1.Schedule_ThursdayStop4

m_iTimeValue(DAY_FRIDAY, PERIOD_1, SCHEDULE_START) = Schedule1.Schedule_FridayStart1
m_iTimeValue(DAY_FRIDAY, PERIOD_1, SCHEDULE_STOP) = Schedule1.Schedule_FridayStop1
m_iTimeValue(DAY_FRIDAY, PERIOD_2, SCHEDULE_START) = Schedule1.Schedule_FridayStart2
m_iTimeValue(DAY_FRIDAY, PERIOD_2, SCHEDULE_STOP) = Schedule1.Schedule_FridayStop2
m_iTimeValue(DAY_FRIDAY, PERIOD_3, SCHEDULE_START) = Schedule1.Schedule_FridayStart3
m_iTimeValue(DAY_FRIDAY, PERIOD_3, SCHEDULE_STOP) = Schedule1.Schedule_FridayStop3
m_iTimeValue(DAY_FRIDAY, PERIOD_4, SCHEDULE_START) = Schedule1.Schedule_FridayStart4
m_iTimeValue(DAY_FRIDAY, PERIOD_4, SCHEDULE_STOP) = Schedule1.Schedule_FridayStop4

m_iTimeValue(DAY_SATURDAY, PERIOD_1, SCHEDULE_START) = Schedule1.Schedule_SaturdayStart1
m_iTimeValue(DAY_SATURDAY, PERIOD_1, SCHEDULE_STOP) = Schedule1.Schedule_SaturdayStop1
m_iTimeValue(DAY_SATURDAY, PERIOD_2, SCHEDULE_START) = Schedule1.Schedule_SaturdayStart2
m_iTimeValue(DAY_SATURDAY, PERIOD_2, SCHEDULE_STOP) = Schedule1.Schedule_SaturdayStop2
m_iTimeValue(DAY_SATURDAY, PERIOD_3, SCHEDULE_START) = Schedule1.Schedule_SaturdayStart3
m_iTimeValue(DAY_SATURDAY, PERIOD_3, SCHEDULE_STOP) = Schedule1.Schedule_SaturdayStop3
m_iTimeValue(DAY_SATURDAY, PERIOD_4, SCHEDULE_START) = Schedule1.Schedule_SaturdayStart4
m_iTimeValue(DAY_SATURDAY, PERIOD_4, SCHEDULE_STOP) = Schedule1.Schedule_SaturdayStop4

m_iTimeValue(DAY_SUNDAY, PERIOD_1, SCHEDULE_START) = Schedule1.Schedule_SundayStart1
m_iTimeValue(DAY_SUNDAY, PERIOD_1, SCHEDULE_STOP) = Schedule1.Schedule_SundayStop1
m_iTimeValue(DAY_SUNDAY, PERIOD_2, SCHEDULE_START) = Schedule1.Schedule_SundayStart2
m_iTimeValue(DAY_SUNDAY, PERIOD_2, SCHEDULE_STOP) = Schedule1.Schedule_SundayStop2
m_iTimeValue(DAY_SUNDAY, PERIOD_3, SCHEDULE_START) = Schedule1.Schedule_SundayStart3
m_iTimeValue(DAY_SUNDAY, PERIOD_3, SCHEDULE_STOP) = Schedule1.Schedule_SundayStop3
m_iTimeValue(DAY_SUNDAY, PERIOD_4, SCHEDULE_START) = Schedule1.Schedule_SundayStart4
m_iTimeValue(DAY_SUNDAY, PERIOD_4, SCHEDULE_STOP) = Schedule1.Schedule_SundayStop4

m_iTimeValue(DAY_SPECIAL, PERIOD_1, SCHEDULE_START) = Schedule1.Schedule_SpecialStart1
m_iTimeValue(DAY_SPECIAL, PERIOD_1, SCHEDULE_STOP) = Schedule1.Schedule_SpecialStop1
m_iTimeValue(DAY_SPECIAL, PERIOD_2, SCHEDULE_START) = Schedule1.Schedule_SpecialStart2
m_iTimeValue(DAY_SPECIAL, PERIOD_2, SCHEDULE_STOP) = Schedule1.Schedule_SpecialStop2
m_iTimeValue(DAY_SPECIAL, PERIOD_3, SCHEDULE_START) = Schedule1.Schedule_SpecialStart3
m_iTimeValue(DAY_SPECIAL, PERIOD_3, SCHEDULE_STOP) = Schedule1.Schedule_SpecialStop3
m_iTimeValue(DAY_SPECIAL, PERIOD_4, SCHEDULE_START) = Schedule1.Schedule_SpecialStart4
m_iTimeValue(DAY_SPECIAL, PERIOD_4, SCHEDULE_STOP) = Schedule1.Schedule_SpecialStop4


NormalExit_LoadTimeValueArray:
    On Error GoTo Resume_LoadTimeValueArray
    'Clean up
    On Error GoTo 0
    Exit Sub

EH_LoadTimeValueArray:
    n_strMessage = "Failed to load time value array with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_LoadTimeValueArray

Resume_LoadTimeValueArray:
    Err.Clear
    Resume Next

End Sub
'******************************************
'* This function writes the current values to the INI file
'* Input:      None
'* Output:     true on success
'* Programmer: MBevan
'* Date:       23/Oct/2005
'******************************************
Private Function WriteValuesToINIFile() As Boolean
Dim n_bReturnValue As Boolean
Dim n_strMessage As String
Dim n_clsINIControl As clsINIControl

On Error GoTo EH_WriteValuesToINIFile
n_bReturnValue = False

Set n_clsINIControl = New clsINIControl

n_clsINIControl.FileName = App.Path & "\" & INI_FILE_NAME

n_clsINIControl.Section = "MONDAY"
n_clsINIControl.Key = "Start1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_MondayStart1)
n_clsINIControl.Key = "Stop1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_MondayStop1)
n_clsINIControl.Key = "Start2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_MondayStart2)
n_clsINIControl.Key = "Stop2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_MondayStop2)
n_clsINIControl.Key = "Start3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_MondayStart3)
n_clsINIControl.Key = "Stop3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_MondayStop3)
n_clsINIControl.Key = "Start4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_MondayStart4)
n_clsINIControl.Key = "Stop4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_MondayStop4)

n_clsINIControl.Section = "TUESDAY"
n_clsINIControl.Key = "Start1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_TuesdayStart1)
n_clsINIControl.Key = "Stop1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_TuesdayStop1)
n_clsINIControl.Key = "Start2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_TuesdayStart2)
n_clsINIControl.Key = "Stop2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_TuesdayStop2)
n_clsINIControl.Key = "Start3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_TuesdayStart3)
n_clsINIControl.Key = "Stop3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_TuesdayStop3)
n_clsINIControl.Key = "Start4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_TuesdayStart4)
n_clsINIControl.Key = "Stop4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_TuesdayStop4)

n_clsINIControl.Section = "WEDNESDAY"
n_clsINIControl.Key = "Start1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_WednesdayStart1)
n_clsINIControl.Key = "Stop1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_WednesdayStop1)
n_clsINIControl.Key = "Start2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_WednesdayStart2)
n_clsINIControl.Key = "Stop2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_WednesdayStop2)
n_clsINIControl.Key = "Start3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_WednesdayStart3)
n_clsINIControl.Key = "Stop3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_WednesdayStop3)
n_clsINIControl.Key = "Start4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_WednesdayStart4)
n_clsINIControl.Key = "Stop4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_WednesdayStop4)

n_clsINIControl.Section = "THURSDAY"
n_clsINIControl.Key = "Start1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_ThursdayStart1)
n_clsINIControl.Key = "Stop1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_ThursdayStop1)
n_clsINIControl.Key = "Start2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_ThursdayStart2)
n_clsINIControl.Key = "Stop2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_ThursdayStop2)
n_clsINIControl.Key = "Start3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_ThursdayStart3)
n_clsINIControl.Key = "Stop3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_ThursdayStop3)
n_clsINIControl.Key = "Start4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_ThursdayStart4)
n_clsINIControl.Key = "Stop4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_ThursdayStop4)

n_clsINIControl.Section = "FRIDAY"
n_clsINIControl.Key = "Start1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_FridayStart1)
n_clsINIControl.Key = "Stop1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_FridayStop1)
n_clsINIControl.Key = "Start2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_FridayStart2)
n_clsINIControl.Key = "Stop2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_FridayStop2)
n_clsINIControl.Key = "Start3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_FridayStart3)
n_clsINIControl.Key = "Stop3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_FridayStop3)
n_clsINIControl.Key = "Start4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_FridayStart4)
n_clsINIControl.Key = "Stop4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_FridayStop4)

n_clsINIControl.Section = "SATURDAY"
n_clsINIControl.Key = "Start1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SaturdayStart1)
n_clsINIControl.Key = "Stop1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SaturdayStop1)
n_clsINIControl.Key = "Start2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SaturdayStart2)
n_clsINIControl.Key = "Stop2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SaturdayStop2)
n_clsINIControl.Key = "Start3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SaturdayStart3)
n_clsINIControl.Key = "Stop3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SaturdayStop3)
n_clsINIControl.Key = "Start4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SaturdayStart4)
n_clsINIControl.Key = "Stop4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SaturdayStop4)

n_clsINIControl.Section = "SUNDAY"
n_clsINIControl.Key = "Start1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SundayStart1)
n_clsINIControl.Key = "Stop1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SundayStop1)
n_clsINIControl.Key = "Start2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SundayStart2)
n_clsINIControl.Key = "Stop2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SundayStop2)
n_clsINIControl.Key = "Start3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SundayStart3)
n_clsINIControl.Key = "Stop3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SundayStop3)
n_clsINIControl.Key = "Start4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SundayStart4)
n_clsINIControl.Key = "Stop4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SundayStop4)

n_clsINIControl.Section = "SPECIAL"
n_clsINIControl.Key = "Start1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SpecialStart1)
n_clsINIControl.Key = "Stop1"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SpecialStop1)
n_clsINIControl.Key = "Start2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SpecialStart2)
n_clsINIControl.Key = "Stop2"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SpecialStop2)
n_clsINIControl.Key = "Start3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SpecialStart3)
n_clsINIControl.Key = "Stop3"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SpecialStop3)
n_clsINIControl.Key = "Start4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SpecialStart4)
n_clsINIControl.Key = "Stop4"
n_clsINIControl.CurrentValue = CStr(Schedule1.Schedule_SpecialStop4)

n_bReturnValue = True

NormalExit_WriteValuesToINIFile:
    On Error GoTo Resume_WriteValuesToINIFile
    
    If Not n_clsINIControl Is Nothing Then Set n_clsINIControl = Nothing
    
    WriteValuesToINIFile = n_bReturnValue
    On Error GoTo 0
    Exit Function

EH_WriteValuesToINIFile:
    n_strMessage = "Failed to write values to the INI file with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_WriteValuesToINIFile

Resume_WriteValuesToINIFile:
    Err.Clear
    Resume Next

End Function

'******************************************
'* This function reads the values from an INI file and sets up the schedule control
'* Input:      None
'* Output:     true if successful
'* Programmer: MBevan
'* Date:       23/Oct/2005
'******************************************
Private Function ReadValuesFromINIFile() As Boolean
Dim n_bReturnValue As Boolean
Dim n_strMessage As String
Dim n_clsINIControl As clsINIControl

On Error GoTo EH_ReadValuesFromINIFile
n_bReturnValue = False

Set n_clsINIControl = New clsINIControl

n_clsINIControl.FileName = App.Path & "\" & INI_FILE_NAME

n_clsINIControl.Section = "MONDAY"
n_clsINIControl.Key = "Start1"
Schedule1.Schedule_MondayStart1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop1"
Schedule1.Schedule_MondayStop1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start2"
Schedule1.Schedule_MondayStart2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop2"
Schedule1.Schedule_MondayStop2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start3"
Schedule1.Schedule_MondayStart3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop3"
Schedule1.Schedule_MondayStop3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start4"
Schedule1.Schedule_MondayStart4 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop4"
Schedule1.Schedule_MondayStop4 = CInt(n_clsINIControl.CurrentValue)

n_clsINIControl.Section = "TUESDAY"
n_clsINIControl.Key = "Start1"
Schedule1.Schedule_TuesdayStart1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop1"
Schedule1.Schedule_TuesdayStop1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start2"
Schedule1.Schedule_TuesdayStart2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop2"
Schedule1.Schedule_TuesdayStop2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start3"
Schedule1.Schedule_TuesdayStart3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop3"
Schedule1.Schedule_TuesdayStop3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start4"
Schedule1.Schedule_TuesdayStart4 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop4"
Schedule1.Schedule_TuesdayStop4 = CInt(n_clsINIControl.CurrentValue)

n_clsINIControl.Section = "WEDNESDAY"
n_clsINIControl.Key = "Start1"
Schedule1.Schedule_WednesdayStart1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop1"
Schedule1.Schedule_WednesdayStop1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start2"
Schedule1.Schedule_WednesdayStart2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop2"
Schedule1.Schedule_WednesdayStop2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start3"
Schedule1.Schedule_WednesdayStart3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop3"
Schedule1.Schedule_WednesdayStop3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start4"
Schedule1.Schedule_WednesdayStart4 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop4"
Schedule1.Schedule_WednesdayStop4 = CInt(n_clsINIControl.CurrentValue)

n_clsINIControl.Section = "THURSDAY"
n_clsINIControl.Key = "Start1"
Schedule1.Schedule_ThursdayStart1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop1"
Schedule1.Schedule_ThursdayStop1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start2"
Schedule1.Schedule_ThursdayStart2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop2"
Schedule1.Schedule_ThursdayStop2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start3"
Schedule1.Schedule_ThursdayStart3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop3"
Schedule1.Schedule_ThursdayStop3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start4"
Schedule1.Schedule_ThursdayStart4 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop4"
Schedule1.Schedule_ThursdayStop4 = CInt(n_clsINIControl.CurrentValue)

n_clsINIControl.Section = "FRIDAY"
n_clsINIControl.Key = "Start1"
Schedule1.Schedule_FridayStart1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop1"
Schedule1.Schedule_FridayStop1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start2"
Schedule1.Schedule_FridayStart2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop2"
Schedule1.Schedule_FridayStop2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start3"
Schedule1.Schedule_FridayStart3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop3"
Schedule1.Schedule_FridayStop3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start4"
Schedule1.Schedule_FridayStart4 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop4"
Schedule1.Schedule_FridayStop4 = CInt(n_clsINIControl.CurrentValue)

n_clsINIControl.Section = "SATURDAY"
n_clsINIControl.Key = "Start1"
Schedule1.Schedule_SaturdayStart1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop1"
Schedule1.Schedule_SaturdayStop1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start2"
Schedule1.Schedule_SaturdayStart2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop2"
Schedule1.Schedule_SaturdayStop2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start3"
Schedule1.Schedule_SaturdayStart3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop3"
Schedule1.Schedule_SaturdayStop3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start4"
Schedule1.Schedule_SaturdayStart4 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop4"
Schedule1.Schedule_SaturdayStop4 = CInt(n_clsINIControl.CurrentValue)

n_clsINIControl.Section = "SUNDAY"
n_clsINIControl.Key = "Start1"
Schedule1.Schedule_SundayStart1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop1"
Schedule1.Schedule_SundayStop1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start2"
Schedule1.Schedule_SundayStart2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop2"
Schedule1.Schedule_SundayStop2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start3"
Schedule1.Schedule_SundayStart3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop3"
Schedule1.Schedule_SundayStop3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start4"
Schedule1.Schedule_SundayStart4 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop4"
Schedule1.Schedule_SundayStop4 = CInt(n_clsINIControl.CurrentValue)

n_clsINIControl.Section = "SPECIAL"
n_clsINIControl.Key = "Start1"
Schedule1.Schedule_SpecialStart1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop1"
Schedule1.Schedule_SpecialStop1 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start2"
Schedule1.Schedule_SpecialStart2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop2"
Schedule1.Schedule_SpecialStop2 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start3"
Schedule1.Schedule_SpecialStart3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop3"
Schedule1.Schedule_SpecialStop3 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Start4"
Schedule1.Schedule_SpecialStart4 = CInt(n_clsINIControl.CurrentValue)
n_clsINIControl.Key = "Stop4"
Schedule1.Schedule_SpecialStop4 = CInt(n_clsINIControl.CurrentValue)

n_bReturnValue = True

NormalExit_ReadValuesFromINIFile:
    On Error GoTo Resume_ReadValuesFromINIFile
    
    If Not n_clsINIControl Is Nothing Then Set n_clsINIControl = Nothing
    
    ReadValuesFromINIFile = n_bReturnValue
    On Error GoTo 0
    Exit Function

EH_ReadValuesFromINIFile:
    n_strMessage = "Failed to read values from INI file with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_ReadValuesFromINIFile

Resume_ReadValuesFromINIFile:
    Err.Clear
    Resume Next

End Function

